searchNodes=[{"doc":"A AssignmentStrategy is strategy to handle assigning events to subscribers to meet their demands.","ref":"Dispenser.AssignmentStrategy.html","title":"Dispenser.AssignmentStrategy","type":"behaviour"},{"doc":"Given subscriber demands and a number of events, determines how to assign the events to the subscribers. Returns a new assigned_demands that contains values for assigning the events to the subscribers, and returns a remaining_demands that are left over for later when there are more events than demand.","ref":"Dispenser.AssignmentStrategy.html#c:assign/2","title":"Dispenser.AssignmentStrategy.assign/2","type":"callback"},{"doc":"The AssignmentStrategy type.","ref":"Dispenser.AssignmentStrategy.html#t:t/0","title":"Dispenser.AssignmentStrategy.t/0","type":"type"},{"doc":"The Even AssignmentStrategy assigns events to as many subscribers as possible, up to their demand. Once a subscribers has its demand satisfied, it is removed from the assignment rounds and the remaining events are assigned to the remaining subscribers. This assignment cycle continues until either all demand is satisfied or all events have been assigned.","ref":"Dispenser.AssignmentStrategy.Even.html","title":"Dispenser.AssignmentStrategy.Even","type":"module"},{"doc":"A Dispenser.Buffer is a buffer that manages incoming events and demand for those events.","ref":"Dispenser.Buffer.html","title":"Dispenser.Buffer","type":"module"},{"doc":"Add events to the Buffer . If the Buffer reaches its capacity, events will be dropped.","ref":"Dispenser.Buffer.html#append/2","title":"Dispenser.Buffer.append/2","type":"function"},{"doc":"Ask for events from the Buffer . These demands are met by calls to assign_events/1","ref":"Dispenser.Buffer.html#ask/3","title":"Dispenser.Buffer.ask/3","type":"function"},{"doc":"Given the current events and demands, returns the events to send to each subscriber.","ref":"Dispenser.Buffer.html#assign_events/1","title":"Dispenser.Buffer.assign_events/1","type":"function"},{"doc":"Remove all demand from the given subscriber.","ref":"Dispenser.Buffer.html#delete/2","title":"Dispenser.Buffer.delete/2","type":"function"},{"doc":"Create a new Buffer with a maximum capacity.","ref":"Dispenser.Buffer.html#new/3","title":"Dispenser.Buffer.new/3","type":"function"},{"doc":"Get the number of events in the Buffer .","ref":"Dispenser.Buffer.html#size/1","title":"Dispenser.Buffer.size/1","type":"function"},{"doc":"Get various statistics about the Buffer for use when debugging and generating metrics.","ref":"Dispenser.Buffer.html#stats/1","title":"Dispenser.Buffer.stats/1","type":"function"},{"doc":"Various statistics exposed by the Buffer for use by debugging and metrics. See stats/1","ref":"Dispenser.Buffer.html#t:stats/0","title":"Dispenser.Buffer.stats/0","type":"type"},{"doc":"The opaque internal state of the Buffer .","ref":"Dispenser.Buffer.html#t:t/2","title":"Dispenser.Buffer.t/2","type":"opaque"},{"doc":"Tracks the demands of subscribers. Keeps a constant-time total/1 of the overall demand. Used by Buffer to keep track of demand for events. Used by implementations of Dispenser.AssignmentStrategy to determine which subscribers to send to.","ref":"Dispenser.Demands.html","title":"Dispenser.Demands","type":"module"},{"doc":"Add some demand for one subscriber. A subscriber can demand as much as it wants.","ref":"Dispenser.Demands.html#add/3","title":"Dispenser.Demands.add/3","type":"function"},{"doc":"Remove the demand of one subscriber.","ref":"Dispenser.Demands.html#delete/2","title":"Dispenser.Demands.delete/2","type":"function"},{"doc":"Get the current demand for one subscriber.","ref":"Dispenser.Demands.html#get/2","title":"Dispenser.Demands.get/2","type":"function"},{"doc":"Create a new Demands .","ref":"Dispenser.Demands.html#new/0","title":"Dispenser.Demands.new/0","type":"function"},{"doc":"The total number of subscribers that have demand &gt; 0.","ref":"Dispenser.Demands.html#size/1","title":"Dispenser.Demands.size/1","type":"function"},{"doc":"Get all subscribers that have demand &gt; 0.","ref":"Dispenser.Demands.html#subscribers/1","title":"Dispenser.Demands.subscribers/1","type":"function"},{"doc":"Remove some demand for one subscriber. Once a subscriber reaches 0 demand, it is no longer tracked by Demands .","ref":"Dispenser.Demands.html#subtract/3","title":"Dispenser.Demands.subtract/3","type":"function"},{"doc":"The total demand of all subscribers.","ref":"Dispenser.Demands.html#total/1","title":"Dispenser.Demands.total/1","type":"function"},{"doc":"The current demand for one subscriber.","ref":"Dispenser.Demands.html#t:demand/0","title":"Dispenser.Demands.demand/0","type":"type"},{"doc":"A map of all subscribers that have demand &gt; 0, with their demands.","ref":"Dispenser.Demands.html#t:subscribers/1","title":"Dispenser.Demands.subscribers/1","type":"type"},{"doc":"The opaque internal state of the Demands .","ref":"Dispenser.Demands.html#t:t/1","title":"Dispenser.Demands.t/1","type":"opaque"},{"doc":"A MonitoredBuffer contains most of the logic required to implement a GenServer that wraps a Buffer . MonitoredBuffer combines a Buffer to track events and a SubscriptionManager to track subscribers.","ref":"Dispenser.MonitoredBuffer.html","title":"Dispenser.MonitoredBuffer","type":"module"},{"doc":"Add events to the MonitoredBuffer . If the MonitoredBuffer reaches its capacity, events will be dropped.","ref":"Dispenser.MonitoredBuffer.html#append/2","title":"Dispenser.MonitoredBuffer.append/2","type":"function"},{"doc":"Ask for events from the Buffer . These demands are met by calls to assign_events/1","ref":"Dispenser.MonitoredBuffer.html#ask/3","title":"Dispenser.MonitoredBuffer.ask/3","type":"function"},{"doc":"Given the current events and demands, returns the events to send to each subscriber.","ref":"Dispenser.MonitoredBuffer.html#assign_events/1","title":"Dispenser.MonitoredBuffer.assign_events/1","type":"function"},{"doc":"Stop monitoring and remove all demand from the given subscriber.","ref":"Dispenser.MonitoredBuffer.html#delete/2","title":"Dispenser.MonitoredBuffer.delete/2","type":"function"},{"doc":"Handle the down signal from a monitored subscriber.","ref":"Dispenser.MonitoredBuffer.html#down/3","title":"Dispenser.MonitoredBuffer.down/3","type":"function"},{"doc":"Create a new MonitoredBuffer that wraps the given Buffer .","ref":"Dispenser.MonitoredBuffer.html#new/1","title":"Dispenser.MonitoredBuffer.new/1","type":"function"},{"doc":"Get the number of events in the MonitoredBuffer .","ref":"Dispenser.MonitoredBuffer.html#size/1","title":"Dispenser.MonitoredBuffer.size/1","type":"function"},{"doc":"Get various statistics about the MonitoredBuffer for use when debugging and generating metrics.","ref":"Dispenser.MonitoredBuffer.html#stats/1","title":"Dispenser.MonitoredBuffer.stats/1","type":"function"},{"doc":"Various statistics exposed by the MonitoredBuffer for use by debugging and metrics. See stats/1","ref":"Dispenser.MonitoredBuffer.html#t:stats/0","title":"Dispenser.MonitoredBuffer.stats/0","type":"type"},{"doc":"The opaque internal state of the MonitoredBuffer .","ref":"Dispenser.MonitoredBuffer.html#t:t/1","title":"Dispenser.MonitoredBuffer.t/1","type":"opaque"},{"doc":"A BatchingBufferServer is an example GenServer that uses Dispenser.Buffer . It can receive events and send them to subscriber processes. The BatchingBufferServer works like BufferServer , but tries to minimize the number of messages sent to subscribers by only sending events when there is a large enough number of them. Subscribers can control the flow by telling the BatchingBufferServer how many events they want, using ask/3 . See ask/3 for more information about how events are sent to subscribers.","ref":"Dispenser.Server.BatchingBufferServer.html","title":"Dispenser.Server.BatchingBufferServer","type":"module"},{"doc":"Add events to the BatchingBufferServer . If the buffer reaches its capacity, an error is returned with the number of events that were were dropped.","ref":"Dispenser.Server.BatchingBufferServer.html#append/2","title":"Dispenser.Server.BatchingBufferServer.append/2","type":"function"},{"doc":"Ask for events from the BatchingBufferServer . Events will be delivered asynchronously to the subscribed pid in the shape of: { :handle_assigned_events , sender , events } where: sender is the pid of this BatchingBufferServer . events is a list of events that were appended to the BatchingBufferServer .","ref":"Dispenser.Server.BatchingBufferServer.html#ask/2","title":"Dispenser.Server.BatchingBufferServer.ask/2","type":"function"},{"doc":"","ref":"Dispenser.Server.BatchingBufferServer.html#ask/3","title":"Dispenser.Server.BatchingBufferServer.ask/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Dispenser.Server.BatchingBufferServer.html#child_spec/1","title":"Dispenser.Server.BatchingBufferServer.child_spec/1","type":"function"},{"doc":"Start a new BatchingBufferServer GenServer . See init_args/0 and GenServer.start_link/2","ref":"Dispenser.Server.BatchingBufferServer.html#start_link/1","title":"Dispenser.Server.BatchingBufferServer.start_link/1","type":"function"},{"doc":"Get various statistics about the BatchingBufferServer for use when debugging and generating metrics.","ref":"Dispenser.Server.BatchingBufferServer.html#stats/1","title":"Dispenser.Server.BatchingBufferServer.stats/1","type":"function"},{"doc":"Unsubscribe from the BatchingBufferServer .","ref":"Dispenser.Server.BatchingBufferServer.html#unsubscribe/1","title":"Dispenser.Server.BatchingBufferServer.unsubscribe/1","type":"function"},{"doc":"","ref":"Dispenser.Server.BatchingBufferServer.html#unsubscribe/2","title":"Dispenser.Server.BatchingBufferServer.unsubscribe/2","type":"function"},{"doc":"The arguments required to create a BatchingBufferServer . :buffer defines the Buffer used internally by the BatchingBufferServer . :batch_size defines the minimum batch size of events to gather before sending them to subscribers. :max_delay defines the maximum amount of time in milliseconds to wait for more events when there are fewer than batch_size events in the buffer. Once max_delay is reached, events will be sent to subscribers even if there are fewer than batch_size events. See start_link/1 .","ref":"Dispenser.Server.BatchingBufferServer.html#t:init_args/1","title":"Dispenser.Server.BatchingBufferServer.init_args/1","type":"type"},{"doc":"The opaque internal state of the BatchingBufferServer .","ref":"Dispenser.Server.BatchingBufferServer.html#t:t/1","title":"Dispenser.Server.BatchingBufferServer.t/1","type":"opaque"},{"doc":"A BufferServer is an example GenServer that uses Dispenser.Buffer . It can receive events and send them to subscriber processes. Subscribers can control the flow by telling the BufferServer how many events they want, using ask/3 . See ask/3 for more information about how events are sent to subscribers.","ref":"Dispenser.Server.BufferServer.html","title":"Dispenser.Server.BufferServer","type":"module"},{"doc":"Add events to the BufferServer . If the buffer reaches its capacity, an error is returned with the number of events that were were dropped.","ref":"Dispenser.Server.BufferServer.html#append/2","title":"Dispenser.Server.BufferServer.append/2","type":"function"},{"doc":"Ask for events from the BufferServer . Events will be delivered asynchronously to the subscribed pid in the shape of: { :handle_assigned_events , sender , events } where: sender is the pid of this BufferServer . events is a list of events that were appended to the BufferServer .","ref":"Dispenser.Server.BufferServer.html#ask/2","title":"Dispenser.Server.BufferServer.ask/2","type":"function"},{"doc":"","ref":"Dispenser.Server.BufferServer.html#ask/3","title":"Dispenser.Server.BufferServer.ask/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Dispenser.Server.BufferServer.html#child_spec/1","title":"Dispenser.Server.BufferServer.child_spec/1","type":"function"},{"doc":"Start a new BufferServer GenServer . See init_args/0 and GenServer.start_link/2","ref":"Dispenser.Server.BufferServer.html#start_link/1","title":"Dispenser.Server.BufferServer.start_link/1","type":"function"},{"doc":"Get various statistics about the BufferServer for use when debugging and generating metrics.","ref":"Dispenser.Server.BufferServer.html#stats/1","title":"Dispenser.Server.BufferServer.stats/1","type":"function"},{"doc":"Unsubscribe from the BufferServer .","ref":"Dispenser.Server.BufferServer.html#unsubscribe/1","title":"Dispenser.Server.BufferServer.unsubscribe/1","type":"function"},{"doc":"","ref":"Dispenser.Server.BufferServer.html#unsubscribe/2","title":"Dispenser.Server.BufferServer.unsubscribe/2","type":"function"},{"doc":"The arguments required to create a BufferServer . :buffer defines the Buffer used internally by the BufferServer . See start_link/1 .","ref":"Dispenser.Server.BufferServer.html#t:init_args/1","title":"Dispenser.Server.BufferServer.init_args/1","type":"type"},{"doc":"The opaque internal state of the BufferServer .","ref":"Dispenser.Server.BufferServer.html#t:t/1","title":"Dispenser.Server.BufferServer.t/1","type":"opaque"},{"doc":"SubscriptionManager handles monitoring and demonitoring subscribers","ref":"Dispenser.SubscriptionManager.html","title":"Dispenser.SubscriptionManager","type":"module"},{"doc":"Stop monitoring the given subscriber.","ref":"Dispenser.SubscriptionManager.html#demonitor/2","title":"Dispenser.SubscriptionManager.demonitor/2","type":"function"},{"doc":"Handle the down signal from a monitored subscriber.","ref":"Dispenser.SubscriptionManager.html#down/3","title":"Dispenser.SubscriptionManager.down/3","type":"function"},{"doc":"Monitor the given pid using Process.monitor/1 . Callers must handle the :DOWN message from this pid.","ref":"Dispenser.SubscriptionManager.html#monitor/2","title":"Dispenser.SubscriptionManager.monitor/2","type":"function"},{"doc":"","ref":"Dispenser.SubscriptionManager.html#new/0","title":"Dispenser.SubscriptionManager.new/0","type":"function"},{"doc":"Get the number of currently monitored subscribers.","ref":"Dispenser.SubscriptionManager.html#size/1","title":"Dispenser.SubscriptionManager.size/1","type":"function"},{"doc":"The opaque internal state of the SubscriptionManager .","ref":"Dispenser.SubscriptionManager.html#t:t/0","title":"Dispenser.SubscriptionManager.t/0","type":"opaque"},{"doc":"dispenser dispenser is an Elixir library for buffering events and sending them to multiple subscribers.","ref":"readme.html","title":"dispenser","type":"extras"},{"doc":"The terminology used in dispenser is similar to the terminology used in gen_stage . events are pieces of data you want to send to subscriber s. A buffer is something that you can put events into. Multiple subscriber s can ask a buffer for any number of events . The amount of events that a subscriber has ask ed for and is waiting to receive is its demand .","ref":"readme.html#terminology","title":"dispenser - Terminology","type":"extras"},{"doc":"The basic function of the library is to accept events and assign them to subscribers . There are two main &quot;modes&quot; for the buffer : Normal Mode: There are more subscription demand s than there are events in the buffer . The buffer is not filling up and events can be sent. Overloaded Mode: There are more events than the subscribers can handle. If the buffer becomes completely filled, it will drop events according to its LimitedQueue.drop_strategy\\0 . Different uses of the library can decide how to handle these cases. Two example GenServer s are implemented along with the library (see below).","ref":"readme.html#overview","title":"dispenser - Overview","type":"extras"},{"doc":"Append events and add subscription demand in any order, and then use Buffer.assign_events/1 to assign events to subscribers. alias Dispenser . { AssignmentStrategy , Buffer } capacity = 4 buffer = Buffer . new ( AssignmentStrategy.Even , capacity , :drop_newest ) # Buffer.size(buffer) == 0 # Buffer.stats(buffer) == %{buffered: 0, demand: 0} events = [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; , &quot;d&quot; , &quot;e&quot; ] { buffer , dropped } = Buffer . append ( buffer , events ) # dropped == 1 # Buffer.stats(buffer) == %{buffered: 4, demand: 0} subscription_1 = make_ref ( ) buffer = Buffer . ask ( buffer , subscription_1 , 2 ) # Buffer.stats(buffer) == %{buffered: 4, demand: 2} subscription_2 = make_ref ( ) buffer = Buffer . ask ( buffer , subscription_2 , 2 ) # Buffer.stats(buffer) == %{buffered: 4, demand: 4} { buffer , assignments } = Buffer . assign_events ( buffer ) # Buffer.stats(buffer) == %{buffered: 0, demand: 0} # assignments == [{^subscription_1, [&quot;a&quot;, &quot;b&quot;]}, {^subscription_2, [&quot;c&quot;, &quot;d&quot;]}]","ref":"readme.html#usage-api","title":"dispenser - Usage / API","type":"extras"},{"doc":"The library is broken into several pieces that can be implemented and tested simply. Dispenser.Demands is an opaque module that keeps track of demands from subscribers. Dispenser.AssignmentStrategy.Even is the assignment method we use to decide which subscribers to send a limited number of events to. It is the only assignment method implemented, but this can be extended to other methods. Dispenser.Buffer is the main buffer that ties everything together and keeps track of demand and events. Dispenser.SubscriptionManager can monitor subscribers and is a helper for building GenServer s that buffer events. Dispenser.MonitoredBuffer combines the Dispenser.Buffer and Dispenser.SubscriptionManager into one module.","ref":"readme.html#helper-modules","title":"dispenser - Helper Modules","type":"extras"},{"doc":"Users of this library will likely implement their own GenServer , but these examples are a good place to start. Most normal uses and error cases of the BufferServer and BatchingBufferServer are covered in the tests. BufferServer The simplest example GenServer is Dispenser.Server.BufferServer , which will accept events and send them to subscribers. Normal State: BufferServer will accept events and immediately send them to subscribers as evenly as it can (see Dispenser.AssignmentStrategy.Even and the associated tests for the assignment logic by itself in Dispenser.AssignmentStrategy.EvenTest ). Overloaded State: The internal buffer is filling up and the BufferServer will immediately send events to any subscriber who ask s. Because of these two modes, the BufferServer 's state will either have some pending demand, or some buffered events, but never both at the same time. When a subscribed process unsubscribes or crashes, it is removed from the BufferServer 's subscribers and any remaining demand for its subscriptions is canceled. Here is a simple example: alias Dispenser . { AssignmentStrategy , Buffer } alias Dispenser.Server.BufferServer capacity = 10 buffer = Buffer . new ( AssignmentStrategy.Even , capacity , :drop_oldest ) buffer_server = BufferServer . start_link ( %{ buffer : buffer } ) :ok = BufferServer . ask ( buffer_server , 1 ) assert BufferServer . stats ( buffer_server ) == %{ buffered : 0 , subscribed : 1 , demand : 1 } events = [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; , &quot;d&quot; , &quot;e&quot; ] { :ok , 0 } = BufferServer . append ( buffer_server , events ) assert_receive { :handle_assigned_events , ^ buffer_server , [ &quot;a&quot; ] } assert BufferServer . stats ( buffer_server ) == %{ buffered : 9 , subscribed : 1 , demand : 0 } Please see the docs for BufferServer.ask/3 for more details on the format of the :handle_assigned_events message. Please see the documentation and associated test ( Dispenser.Server.BufferServerTest ) for more details. BatchingBufferServer Dispenser.Server.BatchingBufferServer is a slightly optimized improvement on BufferServer that will only send events once a minimum batch size of events has been reached. The BatchingBufferServer has the two states from BufferServer , but it has a third state where it is waiting for the buffer to reach a specified size before sending out events. This helps reduce the number of messages sent to subscribers that have demand &gt; 1. Please see the documentation for BatchingBufferServer and associated test ( Dispenser.Server.BatchingBufferServerTest ) for details.","ref":"readme.html#genserver-examples","title":"dispenser - GenServer examples","type":"extras"},{"doc":"Tests can be run by running mix test in the root of the library.","ref":"readme.html#running-the-tests","title":"dispenser - Running the Tests","type":"extras"},{"doc":"This library contains a lot of internal documentation. Documentation is available on HexDocs , or you can generate the documentation from source: $ mix deps.get $ mix docs","ref":"readme.html#generating-documentation","title":"dispenser - Generating Documentation","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Discord Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]